package com.sun.media.sound;

import java.io.File;
import javax.sound.midi.InvalidMidiDataException;
import java.util.Iterator;
import sun.reflect.misc.ReflectUtil;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URLClassLoader;
import java.util.ArrayList;
import javax.sound.midi.Soundbank;
import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import javax.sound.midi.spi.SoundbankReader;

public final class JARSoundbankReader extends SoundbankReader
{
    public JARSoundbankReader() {
    }
    
    private static boolean isZIP(URL url) {
        boolean n = false;
        try {
            InputStream openStream = url.openStream();
            try {
                byte[] b = new byte[4];
                n = (openStream.read(b) == 4);
                if (!(n == 0)) {
                    n = (b[0] == 80 && b[1] == 75 && b[2] == 3 && b[3] == 4);
                }
            }
            finally {
                openStream.close();
            }
        }
        catch (IOException ex) {}
        return n;
    }
    
    @Override
    public Soundbank getSoundbank(URL url) throws InvalidMidiDataException, IOException {
        if (!isZIP(url)) {
            return null;
        }
        ArrayList<Object> list = new ArrayList();
        URLClassLoader instance = URLClassLoader.newInstance(new URL[] { url });
        InputStream resourceAsStream = instance.getResourceAsStream("META-INF/services/javax.sound.midi.Soundbank");
        if (resourceAsStream == null) {
            return null;
        }
        try {
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(resourceAsStream));
            for (String s = bufferedReader.readLine(); s != null; s = bufferedReader.readLine()) {
                if (!s.startsWith("#")) {
                    try {
                        Class<Object> forName = Class.forName(s.trim(), false, instance);
                        if (Soundbank.class.isAssignableFrom(forName)) {
                            list.add((Object)ReflectUtil.newInstance(forName));
                        }
                    }
                    catch (ClassNotFoundException ex) {}
                    catch (InstantiationException ex2) {}
                    catch (IllegalAccessException ex3) {}
                }
            }
        }
        finally {
            resourceAsStream.close();
        }
        if (list.size() == 0) {
            return null;
        }
        if (list.size() == 1) {
            return (Soundbank)list.get(0);
        }
        SimpleSoundbank o = new SimpleSoundbank();
        Iterator<Object> iterator = list.iterator();
        while (iterator.hasNext()) {
            o.addAllInstruments((Soundbank)iterator.next());
        }
        return o;
    }
    
    @Override
    public Soundbank getSoundbank(InputStream inputStream) throws InvalidMidiDataException, IOException {
        return null;
    }
    
    @Override
    public Soundbank getSoundbank(File file) throws InvalidMidiDataException, IOException {
        return this.getSoundbank(file.toURI().toURL());
    }
}
